Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution:

Description

To have Redmine be able to at least use POST method with web hooks upon multiple events, similarly implemented in GitLab or
GitHub. This will allow to integrate Redmine into other networks, which people may use for team communication.

Trigger event examples:

On Issue Created

On New Repository Commit
On Forum Post

On Wiki page edit

On Wiki page created

On New Document added
On New activity

On News posted

etc

To make it better than GitLab, you can even allow users to input custom JSON subscribe headers and subscribe body in order to

make it compatible with any web hook format, else some services might have parsing problems and result in a rejected request.

Related issues:

Related to Redmine - Feature #23368: webook/push notifications Closed

Related to Redmine - Feature #31006: Add feature Webhook New

Has duplicate Redmine - Feature #3971: Add new notification abitily. Closed 2009-10-05
History

#1 - 2018-09-23 18:44 - Anonymous

The only related feature | found: https://www.redmine.org/issues/23368 but is closed

#2 - 2019-02-10 16:53 - Go MAEDA
- Related to Feature #23368: webook/push notifications added

#3 - 2019-02-10 16:53 - Go MAEDA
- Has duplicate Feature #3971: Add new notification abitily. added

#4 - 2020-12-13 19:32 - George Chester
This would be really nice. I'm trying to join in Camunda BPM into a ticket so a ticket can be assigned a proecess. Webhooks would be wonderful.
Anyone got ideas?

#5 - 2021-03-18 11:39 - Oner KonbXxaHoB

This functional is not realized?

#6 - 2022-04-08 10:31 - Ferdinand S

| would also benefit form this feature greatly. We use Shortcut (shortcut.com) as a Scrum tool and it would be great if we could consume Redmine
webhooks in order to update user stories in Shortcut.
Is there any plan for this feature?
https://www.redmine.org/issues/23368

#7 - 2025-05-01 08:03 - Jens Kramer

- File 0001-Issue-Webhooks.patch added

The attached patch implements web hook support - to call / notify external services when something happens in Redmine.

While this patch just implements the issue create / update / delete events, it was built to be easily extended for lifecycle events of other entities.

Web hooks are defined at the user level, and always run in this users' context, regardless of who triggered the actual event. Events on issues a user
cannot see will not trigger this users' configured hooks. The hook payload is JSON and has type (event), timestamp and data (the object involved) top
level elements, using the existing issues/show API template for consistency to render the issue data inside data.

Each hook is defined for a list of events and projects. Whenever one of the events occurs in one of the projects, a POST request is sent to the
configured URL with a payload depending on the event. Webhook signing with a pre-configured secret is implemented using the same algorithm

GitHub uses .

This feature was developed and is in production use at Planio .

We'd very much like this to be integrated into Redmine, since it is really powerful when combined with platforms like Zapier or IFTTT. Zapier for
example allows to define transformations (using Javascript) to change the JSON payload before triggering an action on another service and can
therefore work as an adapter between Redmine and another service, even if the original payload format is not what the other service expects.

#8 - 2025-05-01 09:33 - Go MAEDA
Thank you for sharing this great patch developed at Planio! | believe it would be a very valuable improvement to Redmine.
| have just one concern: currently, it seems that any user can create webhooks.

Since webhooks automatically send data to external services, some administrators might want to restrict or even disable their use for security or data
protection reasons.

To support such requirements, | think it would be helpful to have permission settings to control who can create or use webhooks.

#9 - 2025-05-06 11:52 - Jens Kramer

Yes, | agree that some organizations might want to limit who can use this feature even if users only could share data they can actually see. I'll update
this issue with a second patch that implements this soon.

#10 - 2025-05-12 03:57 - Jens Kramer
- File 0001-Issue-Webhooks.patch added
- File 0002-adds-the-use_webhooks-permission.patch added

| rebased on current master, added a “use_webhooks™ permission and also fixed some random test failures related to the caching of the IP blacklist
configuration.

#11 - 2025-05-12 07:12 - pasquale [:dedalus]

+1

#12 - 2025-05-25 00:19 - Marius BALTEANU
- Related to Feature #31006: Add feature Webhook added

#13 - 2025-05-29 03:37 - Go MAEDA

- Target version set to Candidate for next major release

Files

0001-Issue-Webhooks.patch 40.4 KB 2025-05-01 Jens Kramer
0002-adds-the-use_webhooks-permission.patch 8.12 KB 2025-05-12 Jens Kramer
0001-Issue-Webhooks.patch 40.4 KB 2025-05-12 Jens Kramer
